#define item_type_armor        (0)

#define create_object(X,Y,Z)    create_object_sid(X,Y,Z,-1)

#define critter_wearing_armor(x)            (obj_item_subtype(critter_inven_obj(x,INVEN_TYPE_WORN)) == item_type_armor)

#define METARULE_INVEN_UNWIELD_WHO 43

#define inven_unwield(WHO)       metarule(METARULE_INVEN_UNWIELD_WHO, WHO)

#define give_pid_qty(who_obj, the_pid, pid_qty)                                           \
           restock_obj := create_object(the_pid,0,0);                                     \
           add_mult_objs_to_inven(who_obj, restock_obj, (pid_qty));

#define remove_armor(who_obj)                                                                            \
            if (critter_wearing_armor(who_obj)) then begin                                               \
               restock_obj := critter_inven_obj(who_obj,INVEN_TYPE_WORN);                                \
               debug_msg("armour pid == "+obj_pid(restock_obj));                                         \
               rm_obj_from_inven(who_obj, restock_obj);                                                  \
               add_obj_to_inven(who_obj, restock_obj);                                                   \
            end

#define remove_pid_qty(who_obj, the_pid, pid_qty)                                            \
           removed_qty := obj_is_carrying_obj_pid(who_obj,the_pid);                          \
           if ((pid_qty) < removed_qty) then begin                                           \
              removed_qty := pid_qty;                                                        \
           end                                                                               \
           if (removed_qty > 0) then begin                                                   \
              restock_obj := obj_carrying_pid_obj(who_obj, the_pid);                         \
              if (obj_type(self_obj) == 1) then begin                                        \
                 restock_obj := obj_carrying_pid_obj(who_obj, the_pid);                      \
                 if (critter_inven_obj(self_obj,INVEN_TYPE_WORN) == restock_obj) then begin  \
                    remove_armor(who_obj)                                                    \
                 end else if ((critter_inven_obj(who_obj, INVEN_TYPE_LEFT_HAND) == restock_obj) or (critter_inven_obj(who_obj, INVEN_TYPE_RIGHT_HAND) == restock_obj)) then begin     \
                    inven_unwield(who_obj);                                                  \
                 end                                                                         \
              end                                                                            \
              restock_amt := rm_mult_objs_from_inven(who_obj, restock_obj, removed_qty);     \
              destroy_object(restock_obj);                                                   \
           end                                                                               \
           restock_obj := 0;                                                                 \
           restock_amt := 0;



#define has_create_ingredients(ingredient_1,ingredient_2,ingredient_3,ingredient_4,ingredient_5,critter,number_of_items_1,number_of_items_2,number_of_items_3,number_of_items_4,number_of_items_5,has_tool_1)                                                                                                                                                                         \
   ingredient_one := obj_is_carrying_obj_pid(critter,ingredient_1);                                                                                                                                                                                                                                                                                                                   \
   ingredient_two := obj_is_carrying_obj_pid(critter,ingredient_2);                                                                                                                                                                                                                                                                                                                   \
   ingredient_three := obj_is_carrying_obj_pid(critter,ingredient_3);                                                                                                                                                                                                                                                                                                                 \
   ingredient_four := obj_is_carrying_obj_pid(critter,ingredient_4);                                                                                                                                                                                                                                                                                                                  \
   ingredient_five := obj_is_carrying_obj_pid(critter,ingredient_5);                                                                                                                                                                                                                                                                                                                  \
   has_tool_one := obj_is_carrying_obj_pid(critter,has_tool_1);                                                                                                                                                                                                                                                                                                                       \
   if(has_tool_1 != -1)then begin                                                                                                                                                                                                                                                                                                                                                     \
      if(has_tool_one >= 1) then begin                                                                                                                                                                                                                                                                                                                                                \
         tool_1 := 1;                                                                                                                                                                                                                                                                                                                                                                 \
      end else begin                                                                                                                                                                                                                                                                                                                                                                  \
        tool_1 := 0;                                                                                                                                                                                                                                                                                                                                                                  \
      end                                                                                                                                                                                                                                                                                                                                                                             \
   end else begin                                                                                                                                                                                                                                                                                                                                                                     \
      tool_1 := 1;                                                                                                                                                                                                                                                                                                                                                                    \
   end                                                                                                                                                                                                                                                                                                                                                                                \
   if(ingredient_5 != -1) then begin                                                                                                                                                                                                                                                                                                                                                  \
      if ((ingredient_1 < number_of_items_1) or (ingredient_two < number_of_items_2) or (ingredient_three < number_of_items_3) or (ingredient_four < number_of_items_4) or (ingredient_five < number_of_items_5) or (tool_1 == 0)) then begin                                                                                                                                         \
         set_local_var(LVAR_has_ingredients,0);                                                                                                                                                                                                                                                                                                                                       \
      end else begin                                                                                                                                                                                                                                                                                                                                                                  \
         set_local_var(LVAR_has_ingredients,1);                                                                                                                                                                                                                                                                                                                                       \
      end                                                                                                                                                                                                                                                                                                                                                                             \
   end else if(ingredient_4 != -1) then begin                                                                                                                                                                                                                                                                                                                                         \
      if ((ingredient_one < number_of_items_1) or (ingredient_two < number_of_items_2) or (ingredient_three < number_of_items_3) or (ingredient_four < number_of_items_4) or (tool_1 == 0)) then begin                                                                                                                                                                                \
         set_local_var(LVAR_has_ingredients,0);                                                                                                                                                                                                                                                                                                                                       \
      end else begin                                                                                                                                                                                                                                                                                                                                                                  \
         set_local_var(LVAR_has_ingredients,1);                                                                                                                                                                                                                                                                                                                                       \
      end                                                                                                                                                                                                                                                                                                                                                                             \
   end else if(ingredient_3 != -1) then begin                                                                                                                                                                                                                                                                                                                                         \
      if ((ingredient_one < number_of_items_1) or (ingredient_two < number_of_items_2) or (ingredient_three < number_of_items_3) or (tool_1 == 0)) then begin                                                                                                                                                                                                                         \
         set_local_var(LVAR_has_ingredients,0);                                                                                                                                                                                                                                                                                                                                       \
      end else begin                                                                                                                                                                                                                                                                                                                                                                  \
         set_local_var(LVAR_has_ingredients,1);                                                                                                                                                                                                                                                                                                                                       \
      end                                                                                                                                                                                                                                                                                                                                                                             \
   end else if(ingredient_2 != -1) then begin                                                                                                                                                                                                                                                                                                                                         \
      if ((ingredient_one < number_of_items_1) or (ingredient_two < number_of_items_2) or (tool_1 == 0)) then begin                                                                                                                                                                                                                                                                   \
         set_local_var(LVAR_has_ingredients,0);                                                                                                                                                                                                                                                                                                                                       \
      end else begin                                                                                                                                                                                                                                                                                                                                                                  \
         set_local_var(LVAR_has_ingredients,1);                                                                                                                                                                                                                                                                                                                                       \
      end                                                                                                                                                                                                                                                                                                                                                                             \
   end else begin                                                                                                                                                                                                                                                                                                                                                                     \
      if ((ingredient_one < number_of_items_1) or (tool_1 == 0)) then begin                                                                                                                                                                                                                                                                                                           \
         set_local_var(LVAR_has_ingredients,0);                                                                                                                                                                                                                                                                                                                                       \
      end else begin                                                                                                                                                                                                                                                                                                                                                                  \
         set_local_var(LVAR_has_ingredients,1);                                                                                                                                                                                                                                                                                                                                       \
      end                                                                                                                                                                                                                                                                                                                                                                             \
   end                                                                                                                                                                                                                                                                                                                                                                                \


#define create_healing_items(ingredient_1,ingredient_2,ingredient_3,ingredient_4,ingredient_5,item_to_make,critter,number_of_items_1,number_of_items_2,number_of_items_3,number_of_items_4,number_of_items_5)                                                                                                                                                                         \
   ingredient_one := obj_is_carrying_obj_pid(critter,ingredient_1);                                                                                                                                                                                                                                                                                                                   \
   ingredient_two := obj_is_carrying_obj_pid(critter,ingredient_2);                                                                                                                                                                                                                                                                                                                   \
   ingredient_three := obj_is_carrying_obj_pid(critter,ingredient_3);                                                                                                                                                                                                                                                                                                                 \
   ingredient_four := obj_is_carrying_obj_pid(critter,ingredient_4);                                                                                                                                                                                                                                                                                                                  \
   ingredient_five := obj_is_carrying_obj_pid(critter,ingredient_5);                                                                                                                                                                                                                                                                                                                  \
   if(ingredient_5 != -1) then begin                                                                                                                                                                                                                                                                                                                                                  \
         if (((ingredient_one / number_of_items_1) <= (ingredient_two / number_of_items_2)) and ((ingredient_one / number_of_items_1) <= (ingredient_three / number_of_items_3)) and ((ingredient_one / number_of_items_1) <= (ingredient_four / number_of_items_4)) and ((ingredient_one / number_of_items_1) <= (ingredient_five / number_of_items_5))) then begin                  \
            new_healing_item:=(ingredient_one / number_of_items_1);                                                                                                                                                                                                                                                                                                                   \
         end else if (((ingredient_two / number_of_items_2) <= (ingredient_one / number_of_items_1)) and ((ingredient_two / number_of_items_2) <= (ingredient_three / number_of_items_3)) and ((ingredient_two / number_of_items_2) <= (ingredient_four / number_of_items_4)) and ((ingredient_two / number_of_items_2) <= (ingredient_five / number_of_items_5))) then begin         \
            new_healing_item:=(ingredient_two / number_of_items_2);                                                                                                                                                                                                                                                                                                                   \
         end else if (((ingredient_three / number_of_items_3) <= (ingredient_one / number_of_items_1)) and ((ingredient_three / number_of_items_3) <= (ingredient_two / number_of_items_2)) and ((ingredient_three / number_of_items_3) <= (ingredient_four / number_of_items_4)) and ((ingredient_three / number_of_items_3) <= (ingredient_five / number_of_items_5))) then begin   \
            new_healing_item:=(ingredient_three / number_of_items_3);                                                                                                                                                                                                                                                                                                                 \
         end else if (((ingredient_four / number_of_items_4) <= (ingredient_one / number_of_items_1)) and ((ingredient_four / number_of_items_4) <= (ingredient_three / number_of_items_3)) and ((ingredient_four / number_of_items_4) <= (ingredient_two / number_of_items_2)) and ((ingredient_four / number_of_items_4) <= (ingredient_five / number_of_items_5))) then begin      \
            new_healing_item:=(ingredient_four / number_of_items_4);                                                                                                                                                                                                                                                                                                                  \
         end else if (((ingredient_five / number_of_items_5) <= (ingredient_one / number_of_items_1)) and ((ingredient_five / number_of_items_5) <= (ingredient_two / number_of_items_2)) and ((ingredient_five / number_of_items_5) <= (ingredient_four / number_of_items_4)) and ((ingredient_five / number_of_items_5) <= (ingredient_three / number_of_items_3))) then begin      \
            new_healing_item:=(ingredient_five / number_of_items_5);                                                                                                                                                                                                                                                                                                                  \
         end                                                                                                                                                                                                                                                                                                                                                                          \
   end else if(ingredient_4 != -1) then begin                                                                                                                                                                                                                                                                                                                                         \
         if (((ingredient_one / number_of_items_1) <= (ingredient_two / number_of_items_2)) and ((ingredient_one / number_of_items_1) <= (ingredient_three / number_of_items_3)) and ((ingredient_one / number_of_items_1) <= (ingredient_four / number_of_items_4))) then begin                                                                                                      \
            new_healing_item:=(ingredient_one / number_of_items_1);                                                                                                                                                                                                                                                                                                                   \
         end else if (((ingredient_two / number_of_items_2) <= (ingredient_one / number_of_items_1)) and ((ingredient_two / number_of_items_2) <= (ingredient_three / number_of_items_3)) and ((ingredient_two / number_of_items_2) <= (ingredient_four / number_of_items_4))) then begin                                                                                             \
            new_healing_item:=(ingredient_two / number_of_items_2);                                                                                                                                                                                                                                                                                                                   \
         end else if (((ingredient_three / number_of_items_3) <= (ingredient_one / number_of_items_1)) and ((ingredient_three / number_of_items_3) <= (ingredient_two / number_of_items_2)) and ((ingredient_three / number_of_items_3) <= (ingredient_four / number_of_items_4))) then begin                                                                                         \
            new_healing_item:=(ingredient_three / number_of_items_3);                                                                                                                                                                                                                                                                                                                 \
         end else if (((ingredient_four / number_of_items_4) <= (ingredient_one / number_of_items_1)) and ((ingredient_four / number_of_items_4) <= (ingredient_three / number_of_items_3)) and ((ingredient_four / number_of_items_4) <= (ingredient_two / number_of_items_2))) then begin                                                                                           \
            new_healing_item:=(ingredient_four / number_of_items_4);                                                                                                                                                                                                                                                                                                                  \
         end                                                                                                                                                                                                                                                                                                                                                                          \
   end else if(ingredient_3 != -1) then begin                                                                                                                                                                                                                                                                                                                                         \
         if (((ingredient_one / number_of_items_1) <= (ingredient_two / number_of_items_2)) and ((ingredient_one / number_of_items_1) <= (ingredient_three / number_of_items_3))) then begin                                                                                                                                                                                          \
            new_healing_item:=(ingredient_one / number_of_items_1);                                                                                                                                                                                                                                                                                                                   \
         end else if (((ingredient_two / number_of_items_2) <= (ingredient_one / number_of_items_1)) and ((ingredient_two / number_of_items_2) <= (ingredient_three / number_of_items_3))) then begin                                                                                                                                                                                 \
            new_healing_item:=(ingredient_two / number_of_items_2);                                                                                                                                                                                                                                                                                                                   \
         end else if (((ingredient_three / number_of_items_3) <= (ingredient_one / number_of_items_1)) and ((ingredient_three / number_of_items_3) <= (ingredient_two / number_of_items_2))) then begin                                                                                                                                                                               \
            new_healing_item:=(ingredient_three / number_of_items_3);                                                                                                                                                                                                                                                                                                                 \
         end                                                                                                                                                                                                                                                                                                                                                                          \
   end else if(ingredient_2 != -1) then begin                                                                                                                                                                                                                                                                                                                                         \
         if (((ingredient_one / number_of_items_1) <= (ingredient_two / number_of_items_2))) then begin                                                                                                                                                                                                                                                                               \
            new_healing_item:=(ingredient_one / number_of_items_1);                                                                                                                                                                                                                                                                                                                   \
         end else if (((ingredient_two / number_of_items_2) <= (ingredient_one / number_of_items_1))) then begin                                                                                                                                                                                                                                                                      \
            new_healing_item:=(ingredient_two / number_of_items_2);                                                                                                                                                                                                                                                                                                                   \
         end                                                                                                                                                                                                                                                                                                                                                                          \
   end else if(ingredient_1 != -1) then begin                                                                                                                                                                                                                                                                                                                                         \
         new_healing_item:=(ingredient_one / number_of_items_1);                                                                                                                                                                                                                                                                                                                      \
   end                                                                                                                                                                                                                                                                                                                                                                                \
   delete_1 := obj_carrying_pid_obj(critter,ingredient_1);                                                                                                                                                                                                                                                                                                                            \
   delete_2 := obj_carrying_pid_obj(critter,ingredient_2);                                                                                                                                                                                                                                                                                                                            \
   delete_3 := obj_carrying_pid_obj(critter,ingredient_3);                                                                                                                                                                                                                                                                                                                            \
   delete_4 := obj_carrying_pid_obj(critter,ingredient_4);                                                                                                                                                                                                                                                                                                                            \
   delete_5 := obj_carrying_pid_obj(critter,ingredient_5);                                                                                                                                                                                                                                                                                                                            \
   deleting_1 := rm_mult_objs_from_inven(critter,delete_1,new_healing_item * number_of_items_1);                                                                                                                                                                                                                                                                                      \
   if(ingredient_2 != -1) then begin                                                                                                                                                                                                                                                                                                                                                  \
      deleting_2 := rm_mult_objs_from_inven(critter,delete_2,new_healing_item * number_of_items_2);                                                                                                                                                                                                                                                                                   \
   end                                                                                                                                                                                                                                                                                                                                                                                \
   if(ingredient_3 != -1) then begin                                                                                                                                                                                                                                                                                                                                                  \
      deleting_3 := rm_mult_objs_from_inven(critter,delete_3,new_healing_item * number_of_items_3);                                                                                                                                                                                                                                                                                   \
   end                                                                                                                                                                                                                                                                                                                                                                                \
   if(ingredient_4 != -1) then begin                                                                                                                                                                                                                                                                                                                                                  \
      deleting_4 := rm_mult_objs_from_inven(critter,delete_4,new_healing_item * number_of_items_4);                                                                                                                                                                                                                                                                                   \
   end                                                                                                                                                                                                                                                                                                                                                                                \
   if(ingredient_5 != -1) then begin                                                                                                                                                                                                                                                                                                                                                  \
      deleting_5 := rm_mult_objs_from_inven(critter,delete_5,new_healing_item * number_of_items_5);                                                                                                                                                                                                                                                                                   \
   end                                                                                                                                                                                                                                                                                                                                                                                \
   give_pid_qty(critter, item_to_make, new_healing_item);;                                                                                                                                                                                                                                                                                                                            \

#define LVAR_has_ingredients            (0)

variable new_healing_item := 0;
variable number_of_items_1 := 0;
variable number_of_items_2 := 0;
variable number_of_items_3 := 0;
variable number_of_items_4 := 0;
variable number_of_items_5 := 0;
variable ingredient_one := 0;
variable ingredient_two := 0;
variable ingredient_three := 0;
variable ingredient_four := 0;
variable ingredient_five := 0;
variable ingredient_1 := 0;
variable ingredient_2 := 0;
variable ingredient_3 := 0;
variable ingredient_4 := 0;
variable ingredient_5 := 0;
variable deleting_1 := 0;
variable deleting_2 := 0;
variable deleting_3 := 0;
variable deleting_4 := 0;
variable deleting_5 := 0;
variable delete_1 := 0;
variable delete_2 := 0;
variable delete_3 := 0;
variable delete_4 := 0;
variable delete_5 := 0;
variable has_tool_one := 0;
variable has_tool_1 := 0;
variable tool_1 := 0;